local name, addon = ...
local parentName = addon['parentName'] or "BrokerPack"
local childName = "zz_GarrisonToggle"

local defaults = {
}

local options = {
}

local db

local function OnText(message)
	addon['OnText'](childName, message)
end

local function getPref(pref)
	return db[pref[#pref]]
end

local function setPref(pref,value)
	db[pref[#pref]] = value
end
local function OnButton(self,button)
	if(not IsAddOnLoaded("Blizzard_GarrisonUI")) then
		UIParentLoadAddOn("Blizzard_GarrisonUI")
	end
	if(button=="LeftButton") then
		ToggleFrame(GarrisonLandingPage)
	elseif(button=="RightButton") then
		if(InterfaceOptionsFrame:IsVisible() and not InCombatLockdown()) then
			InterfaceOptionsFrame:Hide()
		else
			InterfaceOptionsFrame_OpenToCategory(childName)
		end
	end
end
local function OnTooltipShow(GameTooltip)
	GameTooltip:AddLine(childName)
	local num = C_Garrison.GetNumFollowers()
	for k,v in pairs(C_Garrison.GetInProgressMissions()) do
		GameTooltip:AddDoubleLine(v['name'],v['timeLeft'])
		num = num - v['numFollowers']
	end
	GameTooltip:AddDoubleLine("Follower:",num.."/"..C_Garrison.GetNumFollowers())
	GameTooltip:AddDoubleLine("Missions:",#C_Garrison.GetInProgressMissions().."/"..#C_Garrison.GetAvailableMissions())
end
local function init()
	options = addon['InitConfig'](addon, childName, true, {
		['type'] = "launcher",
		['OnClick'] = OnButton,
		['OnTooltipShow'] = OnTooltipShow,
		['icon'] = "Interface\\Icons\\Achievement_Arena_2v2_6",
	}, getPref, setPref)
	db = addon['db']['profile'][childName]
end
addon['startup'](addon, name, childName, init, true, defaults)